/* 2004/02/14: I.Q. David Arturo Macias Corona   dbfmysql.prg

Data conversion between databases:
- DBF to DBF. Same or different RDD, but not same filename
- DBF to MySQL
- MySQL to DBF
- MySQL to MySQL. Not same table name

using ClipNet-xNet in:
- http mode
  http://address/dbfmysql.prg
- command line mode
  clipxnet.exe dbfmysql.prg

WARNING: in http mode with big files, conversion process time can go beyond timeout of Web Server
In this case of big files is preferable to use command line mode
*/

#define  TRUE   .T.
#define  FALSE  .F.
#define  K_ESC  27


FUNC MAIN

PRIV nRow, nRow0
PRIV ii
PRIV jj
PRIV cSvrLogos := "../cgi-bin/logos/"
PRIV cContador := "dbfmysql.cnt"

PRIV cMetodo := SGCGIvaria("REQUEST_METHOD")

//Valores para FUENTE
PRIV lesMySQL := .F.   //Diferenciar proceso para DBF o MySQL
PRIV cMySQLhost := SGCGIvaria( "cMySQLhost" )
PRIV cMySQLuser := SGCGIvaria( "cMySQLuser" )
PRIV cMySQLpass := SGCGIvaria( "cMySQLpass" )
PRIV cBaseSQL := SGCGIvaria( "cBaseSQL" )
PRIV cTableSQL := SGCGIvaria( "cTableSQL" )
PRIV oServer   //Conexion a MySQL
PRIV oTable    //Resultado de la consulta
PRIV oRecord   //Fila
PRIV cWhereSQL

PRIV aRdd := { "DBFCDX", "DBFNTX" }
PRIV lAds := "WINDOWS" $ UPPE(OS()) .OR. "LINUX" $ UPPE(OS())
IF lAds
 aRdd := { "DBFCDX", "DBFNTX", "DBFCDXAX", "DBFNTXAX", "ADSCDX", "ADSNTX" }
ENDI
PRIV nCheckADS
PRIV lCheckADS

PRIV cBaseDBF
PRIV cBaseDBF1 := SGCGIvaria( "cBasedbf1" )
PRIV cBaseDBF2 := SGCGIvaria( "cBasedbf2" )
PRIV cIndice := SGCGIvaria( "cIndice" )
PRIV cOrden := SGCGIvaria( "cOrden" )
PRIV cRDD := UPPE( SGCGIvaria( "cRDD" ) )
PRIV cADStipo := UPPE( SGCGIvaria( "cADStipo" ) )
PRIV nRecno := VAL( SGCGIvaria( "nRecno" ) )
PRIV nRango := VAL( SGCGIvaria( "nRango" ) )
PRIV cFiltro := SGCGIvaria( "cFiltro" )
PRIV cCampos := SGCGIvaria( "cCampos" )

PRIV nPos
PRIV cField
PRIV cCadena
PRIV cScrName

//Visualizacion/edicion de registro individual
// PRIV cUsuario
// PRIV cPassWd

PRIV aEstruc
PRIV aEstruc2
PRIV cAlias
PRIV cAlias2
PRIV cTipo
PRIV cValor
PRIV cVarLen
PRIV cVarVal

//Uso de condicion en vez de filtro
PRIV xFor

//Valores para DESTINO
PRIV lesMySQL2 := .F.   //Diferenciar proceso para DBF o MySQL
PRIV cMySQLhost2 := SGCGIvaria( "cMySQLhost2" )
PRIV cMySQLuser2 := SGCGIvaria( "cMySQLuser2" )
PRIV cMySQLpass2 := SGCGIvaria( "cMySQLpass2" )
PRIV cBaseSQL2 := SGCGIvaria( "cBaseSQL2" )
PRIV cTableSQL2 := SGCGIvaria( "cTableSQL2" )
PRIV oServer2   //Conexion a MySQL
PRIV oTable2    //Resultado de la consulta
PRIV oRecord2   //Fila

PRIV lCrear2 := SGCGIvaria( "LCREAR2",,.T. )
PRIV cBaseDBFb
PRIV cBaseDBF12 := SGCGIvaria( "cBasedbf12" )
PRIV cBaseDBF22 := SGCGIvaria( "cBasedbf22" )
PRIV cIndice2 := SGCGIvaria( "cIndice2" )
PRIV cOrden2 := SGCGIvaria( "cOrden2" )
PRIV cRDD2 := UPPE( SGCGIvaria( "cRDD2" ) )
PRIV cADStipo2 := UPPE( SGCGIvaria( "cADStipo2" ) )

IF EMPTY( cBaseDBF1+cBaseDBF2+cMySQLhost+cMySQLuser+cBaseSQL+cTableSQL ) .OR. ;   //No se especificaron para FUENTE
   EMPTY( cBaseDBF12+cBaseDBF22+cMySQLhost2+cMySQLuser2+cBaseSQL2+cTableSQL2 )    //No se especificaron para DESTINO
 IF ! DMCONDIC( ) .OR. lHTML
  RETU NIL
 ENDI
ENDI

//Por omision se procesan archivos DBF
lesMySQL := ( ! EMPTY( cMySQLhost ) .AND. ;
              ! EMPTY( cBaseSQL ) .AND. ;
              ! EMPTY( cTableSQL ) )
lesMySQL2 := ( ! EMPTY( cMySQLhost2 ) .AND. ;
               ! EMPTY( cBaseSQL2 ) .AND. ;
               ! EMPTY( cTableSQL2 ) )
IF lHTML
/* Se puede usar:
- SGOutStd(): para simular la salida directa al servidor Web
  En este caso no se requiere cArcSale, y no debe usarse QOUT()
- cArcSale y QOUT(): para enviar la salida al archivo cArcSale, el cual es definido y usado por el modelo ClipxNet
  para usarlo como "salida" que se enviara al servidor Web
*/

// Escribir informacion en archivo de salida
SGSALIDA0( cArcSale, .T., .F., .F. )

QOUT('<HTML>')
QOUT('<HEAD><TITLE>Modelo ClipxNet: Conversion de datos entre bases de datos</TITLE>')
QOUT('   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">' )
QOUT('   <META NAME="Author" CONTENT="David Arturo Macias Corona">' )
QOUT('   <META NAME="GENERATOR" CONTENT="Mozilla/4.04 [en] (OS/2; I) [Netscape]">' )
QOUT('   <META NAME="GENERATOR" CONTENT="Sistemas Genericos [SGD]">' )
QOUT('</HEAD>')

// QOUT('<BODY background="'+cSvrLogos+'fondo0.gif" leftMargin=5 topMargin=5>')
QOUT('<BODY >')

QOUT('<p align="center">' )
QOUT('<img border="0" src="../cgi-bin/logos/logo.jpg" width="750" height="57" >')
QOUT('</p>')

ENDI

//Preparacion de FUENTE
DO CASE
CASE ! lesMySQL
 // Base de datos DBF
 cBaseDBF := cBaseDBF2  //Archivo de listado
 IF ! EMPTY( cBaseDBF1 )   //Archivo escrito tiene prioridad sobre archivo de listado
  cBaseDBF := cBaseDBF1
 ENDI
 IF EMPTY( cBaseDBF )
  DMSALE( 'FUENTE: Debe especificar una base de datos tipo DBF' )
  RETU
 ENDI
 IF ! FILE( cBaseDBF )
  DMSALE( 'FUENTE: No existe la base de datos: '+cBaseDBF )
  RETU
 ENDI

 CHARDDSetDefault( "DBFCDX" )  //Establecer RDD por omision
 IF EMPTY( cRdd ) .OR. ;
  ( ASCAN( aRdd, SGBLOCK( '|x| UPPE(ALLTRIM(cRdd)) == x ' ) ) == 0 )
  cRdd := CHARDDSETDEFAULT()  //Usar el RDD actual
 ENDI
 CHARDDSetDefault( cRdd )  //Establecer RDD por omision
 IF "ADS" $ cRdd .OR. "AX" $ cRdd    //Advantage
  IF cADStipo == "LOCAL"
   CHASetServer( 1 )   //ADS Local Server
  ELSE
   CHASetServer( 2 )   //ADS Remote Server

   IF lLinux
    //Pendiente implementar verificacion de ADS activo
    //Tomar en consideracion de que INKEY(n) no funciona sin "ncurses"

   ELSE
    //5 intentos de verificacion de ADS activo
    nCheckADS := 1
    lCheckADS := .F.
    WHIL ! ( lCheckADS := CHALoaded( CHAGetDrive( cBaseDBF ) ) ) .AND. ;  //Verificar Servidor ADS activo
     nCheckADS <= 5
     INKEY(0.5)
     nCheckADS := nCheckADS+1
    ENDD
    IF ! lCheckADS   //No hay Servidor ADS activo
     DMSALE( 'FUENTE: No se tiene disponible ADS remoto' )
     RETU
    ENDI
   ENDI
  ENDI
 ENDI

 // CPERUSE: Base,Modo Exclusivo,Segundos,usar mensaje,Area,Alias,Solo Lectura,RDD
 IF ! CPERUSE( cBaseDBF,.F.,5,.F., 1, ,.F., )
  DMSALE( 'FUENTE: No puede accesarse la base de datos: '+cBaseDBF )
  RETU
 ENDI
 cAlias := ALIAS()
 aEstruc := (cAlias)->(DBSTRUCT( ))

 IF ! EMPTY( cIndice ) .AND. FILE( FILEPATH(cBaseDBF)+cIndice )
  OrdListAdd( FILEPATH(cBaseDBF)+cIndice )
 ENDI
 OrdSetFocus( 1 )  //Nota: RDD de ordenes multiples por omision no establecen orden controlador
 IF ! EMPTY( cOrden )
  OrdSetFocus( cOrden )
 ENDI

 IF ! EMPTY( cFiltro )
  // Usar AOFSetFilter() si esta habilitado AOF, en lugar de DBSETFILTER()
  //   Se debe usar solo una de ambas funciones
  DBSETFILTER( SGBLOCK( cFiltro ), cFiltro )
 ENDI

 (cAlias)->(DBGOTOP())

CASE lesMySQL

 IF EMPTY( cMySQLhost )
  DMSALE( 'FUENTE: Debe especificar servidor MySQL' )
  RETU
 ENDI
 IF EMPTY( cBaseSQL ) .OR. EMPTY( cTableSQL )
  DMSALE( 'FUENTE: Debe especificar base de datos y tabla MySQL' )
  RETU
 ENDI

 oServer := TMySQLServer():New( cMySQLhost, cMySQLuser, cMySQLpass )
 IF oServer:NetErr()
  DMSALE( 'FUENTE: No puede conectarse al servidor MySQL '+cMySQLhost ;
   +';Error: ' + oServer:error() )
  RETU
 ENDI

 oServer:SelectDB( cBaseSQL )
 IF oServer:NetErr()
  DMSALE( 'FUENTE: No puede accesarse la base de datos '+cBaseSQL ;
   +';Error: ' + oServer:error() )
  oServer:Destroy()
  RETU
 ENDI

 oTable := oServer:Query("SELECT * FROM " + cTableSQL + " LIMIT 1")
 IF oTable:NetErr()
  DMSALE( 'FUENTE: No puede accesarse la tabla '+cTableSQL ;
   +';Error: ' + oTable:error() )
  oTable:Destroy()
  oServer:Destroy()
  RETU
 ENDI

 aEstruc := { }
 FOR ii = 1 TO oTable:FCOUNT()
  AADD( aEstruc, { oTable:FieldName( ii ), ;
                   oTable:FieldType( ii ), ;
                   oTable:FieldLen( ii ), ;
                   oTable:FieldDec( ii ) } )
 NEXT ii

 oTable:Destroy()

 /* Pendiente: indice(s) para MySQL
 IF ! EMPTY( cIndice ) .AND. FILE( FILEPATH(cBaseDBF)+cIndice )
  OrdListAdd( FILEPATH(cBaseDBF)+cIndice )
 ENDI
 OrdSetFocus( 1 )  //Nota: RDD de ordenes multiples por omision no establecen orden controlador
 IF ! EMPTY( cOrden )
  OrdSetFocus( cOrden )
 ENDI
 */

 cWhereSQL := ""
 IF ! EMPTY( cFiltro )
  cWhereSQL := " WHERE "+cFiltro
 ENDI

 oTable := oServer:Query( "SELECT * FROM " + cTableSQL + cWhereSQL )
 IF oTable:NetErr()
  DMSALE( 'FUENTE: No puede accesarse la tabla '+cTableSQL ;
   +';Error: ' + oTable:error() )
  RETU
  oTable:Destroy()
  oServer:Destroy()
 ENDI
 oTable:GOTOP()

ENDC

IF EMPTY( nRecno )
 nRecno := IF( lesMySQL, oTable:RECNO(), (cAlias)->(RECNO()) )
ENDI
IF ! EMPTY( nRecno )
 IF lesMySQL
  oTable:GOTO( nRecno )
 ELSE
  (cAlias)->(DBGOTO( nRecno ))
 ENDI
ENDI
IF EMPTY( nRango )
 nRango := IF( lesMySQL, oTable:LASTREC(), (cAlias)->(LASTREC()) )
ENDI

//Conformar campos a convertir, y estructura de archivo destino
aEstruc2 := {}
cCadena := UPPE( cCampos )
IF ! EMPTY( cCadena )
 WHILE ! EMPTY( cCadena )
  nPos := AT( ",", cCadena )
  IF ! nPos == 0
   cField := LEFT( cCadena, nPos - 1 )
   cCadena := SUBS( cCadena, nPos + 1 )
  ELSE
   cField := cCadena
   cCadena := ""
  ENDI
  cField := ALLTRIM( cField )
  IF ! ( nPos := IF( lesMySQL, oTable:FIELDPOS( cField ), (cAlias)->(FIELDPOS( cField )) ) ) == 0
   AADD( aEstruc2, { aEstruc[nPos,1], ;
                     aEstruc[nPos,2], ;
                     aEstruc[nPos,3], ;
                     aEstruc[nPos,4] } )
  ENDI
 ENDD
ENDI
IF EMPTY( aEstruc2 )
 //Usar todos los campos de la base de datos
 aEstruc2 := ACLONE( aEstruc )
ENDI

//Preparacion de DESTINO
DO CASE
CASE ! lesMySQL2
 // Base de datos DBF
 cBaseDBFb := cBaseDBF22  //Archivo de listado
 IF ! EMPTY( cBaseDBF12 )   //Archivo escrito tiene prioridad sobre archivo de listado
  cBaseDBFb := cBaseDBF12
 ENDI
 IF EMPTY( cBaseDBFb )
  IF lesMySQL
   oTable:Destroy()
   oServer:Destroy()
  ELSE
   (cAlias)->( DBCLOSEAREA( ) )
  ENDI
  DMSALE('DESTINO: Debe especificar una base de datos tipo DBF' )
  RETU
 ENDI
 IF ! lesMySQL .AND. ( UPPE( cBaseDBF ) == UPPE( cBaseDBFb ) )
  IF lesMySQL
//   oTable:Destroy()
//   oServer:Destroy()
  ELSE
   (cAlias)->( DBCLOSEAREA( ) )
  ENDI
  DMSALE('FUENTE y DESTINO deben tener nombre de archivo diferente' )
  RETU
 
 ENDI
 
 IF ! FILE( cBaseDBFb ) .AND. ! lCrear2
  IF lesMySQL
   oTable:Destroy()
   oServer:Destroy()
  ELSE
   (cAlias)->( DBCLOSEAREA( ) )
  ENDI
  DMSALE('No existe la base de datos: '+cBaseDBFb )
  RETU
 ENDI

// CHARDDSetDefault( "DBFCDX" )  //Establecer RDD por omision
 IF EMPTY( cRdd2 ) .OR. ;
  ( ASCAN( aRdd, SGBLOCK( '|x| UPPE(ALLTRIM(cRdd2)) == x ' ) ) == 0 )
  cRdd2 := CHARDDSETDEFAULT()  //Usar el RDD actual
 ENDI
 // CHARDDSetDefault( cRdd )  //Establecer RDD por omision
 IF "ADS" $ cRdd2 .OR. "AX" $ cRdd2    //Advantage
  IF cADStipo2 == "LOCAL"
   CHASetServer( 1 )   //ADS Local Server
  ELSE
   CHASetServer( 2 )   //ADS Remote Server

   IF lLinux
    //Pendiente implementar verificacion de ADS activo
    //Tomar en consideracion de que INKEY(n) no funciona sin "ncurses"

   ELSE
    //5 intentos de verificacion de ADS activo
    nCheckADS := 1
    lCheckADS := .F.
    WHIL ! ( lCheckADS := CHALoaded( CHAGetDrive( cBaseDBFb ) ) ) .AND. ;  //Verificar Servidor ADS activo
     nCheckADS <= 5
     INKEY(0.5)
     nCheckADS := nCheckADS+1
    ENDD
    IF ! lCheckADS   //No hay Servidor ADS activo
     IF lesMySQL
      oTable:Destroy()
      oServer:Destroy()
     ELSE
      (cAlias)->( DBCLOSEAREA( ) )
     ENDI
     DMSALE('DESTINO: No se tiene disponible ADS remoto' )
     RETU
    ENDI
   ENDI
  ENDI
 ENDI

 IF lCrear2
  IF FILE( cBaseDBFb )
   FERASE( cBaseDBFb )
  ENDI
  CHADbCreate( (cBaseDBFb), aEstruc2, cRdd2 )
 ENDI
 
 // CPERUSE: Base,Modo Exclusivo,Segundos,usar mensaje,Area,Alias,Solo Lectura,RDD
 IF ! CPERUSE( cBaseDBFb,.F.,5,.F., 2, ,.F., cRdd2 )
  IF lesMySQL
   oTable:Destroy()
   oServer:Destroy()
  ELSE
   (cAlias)->( DBCLOSEAREA( ) )
  ENDI
  DMSALE('DESTINO: No puede accesarse la base de datos '+cBaseDBFb)
  RETU
 ENDI
 cAlias2 := ALIAS()

 IF ! EMPTY( cIndice2 ) .AND. FILE( FILEPATH(cBaseDBFb)+cIndice2 )
  OrdListAdd( FILEPATH(cBaseDBFb)+cIndice2 )
 ENDI
 OrdSetFocus( 1 )  //Nota: RDD de ordenes multiples por omision no establecen orden controlador
 IF ! EMPTY( cOrden2 )
  OrdSetFocus( cOrden2 )
 ENDI

 (cAlias2)->(DBGOTOP())

CASE lesMySQL2

 IF EMPTY( cMySQLhost2 )
  IF lesMySQL
   oTable:Destroy()
   oServer:Destroy()
  ELSE
   (cAlias)->( DBCLOSEAREA( ) )
  ENDI
  DMSALE('DESTINO: Debe especificar servidor MySQL' )
  RETU
 ENDI
 IF EMPTY( cBaseSQL2 ) .OR. EMPTY( cTableSQL2 )
  IF lesMySQL
   oTable:Destroy()
   oServer:Destroy()
  ELSE
   (cAlias)->( DBCLOSEAREA( ) )
  ENDI
  DMSALE('DESTINO: Debe especificar base de datos y tabla MySQL' )
  RETU
 ENDI

 IF lesMySQL .AND. ( UPPE( cMySQLhost+cBaseSQL+cTableSQL ) == UPPE( cMySQLhost2+cBaseSQL2+cTableSQL2 ) )
  IF lesMySQL
   oTable:Destroy()
   oServer:Destroy()
  ELSE
   (cAlias)->( DBCLOSEAREA( ) )
  ENDI
  DMSALE('FUENTE y DESTINO deben ser tablas MySQL diferentes' )
  RETU
 
 ENDI
 oServer2 := TMySQLServer():New( cMySQLhost2, cMySQLuser2, cMySQLpass2 )
 IF oServer2:NetErr()
  IF lesMySQL
   oTable:Destroy()
   oServer:Destroy()
  ELSE
   (cAlias)->( DBCLOSEAREA( ) )
  ENDI
  DMSALE('DESTINO: No puede conectarse al servidor MySQL '+cMySQLhost2 ;
   +';Error: ' + oServer2:error() )
  oServer2:Destroy()
  RETU
 ENDI

 oServer2:SelectDB( cBaseSQL2 )
 IF oServer2:NetErr()
  IF lesMySQL
   oTable:Destroy()
   oServer:Destroy()
  ELSE
   (cAlias)->( DBCLOSEAREA( ) )
  ENDI
  DMSALE('DESTINO: No puede accesarse la base de datos '+cBaseSQL2 ;
   +';Error: ' + oServer2:error() )
  oServer2:Destroy()
  RETU
 ENDI

 IF ! Ascan(oServer2:ListTables(), cTableSQL2) > 0 .AND. ! lCrear2
  IF lesMySQL
   oTable:Destroy()
   oServer:Destroy()
  ELSE
   (cAlias)->( DBCLOSEAREA( ) )
  ENDI
  DMSALE('DESTINO: No existe la tabla: '+cTableSQL2 )
  oServer2:Destroy()
  RETU
 ENDI
 
 IF lCrear2
  IF ASCAN(oServer2:ListTables(), cTableSQL2) > 0
   oServer2:DeleteTable(cTableSQL2)
   IF oServer2:NetErr()
    IF lesMySQL
     oTable:Destroy()
     oServer:Destroy()
    ELSE
     (cAlias)->( DBCLOSEAREA( ) )
    ENDI
    DMSALE('DESTINO: No pudo borrarse la tabla '+cTableSQL2 ;
     +';Error: ' + oServer2:error() )
    oServer2:Destroy()
    RETU
   ENDI
  ENDI
  oServer2:CreateTable(cTableSQL2, aEstruc2)
  IF oServer2:NetErr()
   IF lesMySQL
    oTable:Destroy()
    oServer:Destroy()
   ELSE
    (cAlias)->( DBCLOSEAREA( ) )
   ENDI
   DMSALE('DESTINO: No pudo crearse la tabla '+cTableSQL2 ;
    +';Error: ' + oServer2:error() )
   oServer2:Destroy()
   RETU
  ENDI
 ENDI

 oTable2 := oServer2:Query("SELECT * FROM " + cTableSQL2 + " LIMIT 1")
 IF oTable2:NetErr()
  IF lesMySQL
   oTable:Destroy()
   oServer:Destroy()
  ELSE
   (cAlias)->( DBCLOSEAREA( ) )
  ENDI
  DMSALE('DESTINO: No puede accesarse la tabla '+cTableSQL2 ;
   +';Error: ' + oTable2:error() )
  oTable2:Destroy()
  oServer2:Destroy()
  RETU
 ENDI

 /* Pendiente: indice(s) para MySQL
 IF ! EMPTY( cIndice ) .AND. FILE( FILEPATH(cBaseDBF)+cIndice )
  OrdListAdd( FILEPATH(cBaseDBF)+cIndice )
 ENDI
 OrdSetFocus( 1 )  //Nota: RDD de ordenes multiples por omision no establecen orden controlador
 IF ! EMPTY( cOrden )
  OrdSetFocus( cOrden )
 ENDI
 */

ENDC

//Condiciones. Podria aplicarse filtro en lugar de FOR
xFor := ".t."
//Crear bloque de codigo
xFor := SGBLOCK( xFor )

IF lHTML
 QOUT('<div align="center"><center>')
 QOUT('<table border="0" cellpadding="1" cellspacing="1" width="100%">')
 QOUT('<tr>')
 QOUT('<td width="424"><p align="center"><b><font face="Comic Sans MS" color="#000080" size="5">')
 QOUT('Condiciones para copiado de datos tipo DBF y/o MySQL' )
 QOUT('</font></b></td>')
 QOUT('</tr>')
 QOUT('</table>')
 QOUT('</center></div>')

 QOUT('<HR>')
 QOUT( 'Condiciones para archivo FUENTE tipo DBF o MySQL:' )
 IF lesMySQL
  QOUT('<BR>Servidor de datos MySQL: '+cMySQLhost )
  QOUT('<BR>Base de datos MySQL: '+cBaseSQL )
  QOUT('<BR>Tabla: '+cTableSQL )
 ELSE
  QOUT('<BR>Base de datos: '+cBaseDBF )
 ENDI
 IF ! EMPTY( cIndice )
  QOUT('  Indice: '+cIndice )
 ENDI
 IF ! EMPTY( cOrden )
  QOUT('  Orden: '+cOrden )
 ENDI
 IF lesMySQL
  QOUT( '<BR>Controlador RDD: MySQL' )
 ELSE
  QOUT( '<BR>Controlador RDD:'+(cAlias)->(CHARddName( )) )
  IF "ADS" $ cRdd .OR. "AX" $ cRdd    //Advantage
   QQOUT( ',  ADS '+cADStipo )
  ENDI
 ENDI
 IF ! EMPTY( cFiltro )
  QOUT( "<BR>Filtro: "+cFiltro )
 ENDI
 IF ! EMPTY( cCampos )
  QOUT( "<BR>Campos: "+cCampos )
 ENDI

 QOUT('<HR>')
 QOUT( 'Condiciones para archivo DESTINO tipo DBF o MySQL:' )
 IF lesMySQL2
  QOUT('<BR>Servidor de datos MySQL: '+cMySQLhost2 )
  QOUT('<BR>Base de datos MySQL: '+cBaseSQL2 )
  QOUT('<BR>Tabla: '+cTableSQL2 )
 ELSE
  QOUT('<BR>Base de datos: '+cBaseDBFb )
 ENDI
 IF ! EMPTY( cIndice2 )
  QOUT('  Indice: '+cIndice2 )
 ENDI
 IF ! EMPTY( cOrden2 )
  QOUT('  Orden: '+cOrden2 )
 ENDI
 IF lesMySQL2
  QOUT( '<BR>Controlador RDD: MySQL' )
 ELSE
  QOUT( '<BR>Controlador RDD:'+(cAlias2)->(CHARddName( )) )
  IF "ADS" $ cRdd2 .OR. "AX" $ cRdd2    //Advantage
   QQOUT( ',  ADS '+cADStipo2 )
  ENDI
 ENDI
 QOUT('<HR>')

ENDI

// A copiar ... y cerrar

DO CASE
CASE ! lesMySQL
 //DBF a DBF o MySQL
 DBSELECTAREA( cAlias )
 nCheckADS := SECONDS()
 QOUT( IF(lHTML,"<BR>","")+"Tiempo inicial: "+DTOC(DATE())+" "+TIME() )
 // Ciclo para registros
 jj := 0
 WHIL jj < nRango .AND. ! (cAlias)->(EOF()) .AND. IF( lHTML, .T., ! INKEY() == K_ESC )
  IF ! EVAL( xFor )
   (cAlias)->(DBSKIP( 1 ))
   LOOP
  ENDI
  IF ! lesMySQL2
   IF (cAlias2)->(CPERAPPEND(5,.F. )) //Registrar si se agrega registro
    FOR ii = 1 TO LEN( aEstruc2 )
     cVarVal := (cAlias)->(FIELDGET( FIELDPOS(aEstruc2[ ii,1 ]) ))
     (cAlias2)->(FIELDPUT( ii, cVarVal ))
    NEXT ii
    DBCOMMITALL()  //Forza escritura disco
    (cAlias2)->(DBRUNLOCK())
   ELSE
    QOUT( IF(lHTML,"<BR>","")+"Error para agregar desde registro: ", (cAlias)->(RECNO()) )
   ENDI
  
  ELSE
   oRecord2 := oTable2:GetBlankRow()
   FOR ii = 1 TO LEN( aEstruc2 )
    cVarVal := (cAlias)->(FIELDGET( FIELDPOS(aEstruc2[ ii,1 ]) ))
    oRecord2:FIELDPUT( ii, cVarVal )
   NEXT ii
   IF ! oTable2:Append( oRecord2 )
    QOUT( IF(lHTML,"<BR>","")+"Error para agregar desde registro: ", (cAlias)->(RECNO()) )
   ENDI
  ENDI
  
  jj := jj+1
  IF ! lHTML .AND. jj % 100 == 0
   nRow0 := ROW()
   @ nRow,0 SAY "Datos copiados: "+STR(jj,10,0)
   SetPos(nRow0,0)
  ENDI
  (cAlias)->(DBSKIP( 1 ))
  
 ENDD
 QOUT( IF(lHTML,"<BR>","") )
 QOUT( IF(lHTML,"<BR>","")+"Total de datos copiados: "+STR(jj,10,0) ;
  +IF(lHTML,"",IF(LASTKEY()==K_ESC," **CANCELADO** ","") ) )
 QOUT( IF(lHTML,"<BR>","")+"Tiempo final: "+DTOC(DATE())+" "+TIME() )
 QOUT( IF(lHTML,"<BR>","")+"Segundos transcurridos: ", SECONDS()-nCheckADS )
 
 (cAlias)->( DBCLOSEAREA( ) )
 DO CASE
 CASE ! lesMySQL2
  //DBF a DBF
  (cAlias2)->( DBCLOSEAREA( ) )
 CASE lesMySQL2
  //DBF a MySQL
  oTable2:Destroy()
  oServer2:Destroy()
 ENDC

CASE lesMySQL
 //MySQL a DBF o MySQL
 
 nCheckADS := SECONDS()
 QOUT( IF(lHTML,"<BR>","")+"Tiempo inicial: "+DTOC(DATE())+" "+TIME() )
 // Ciclo para registros
 jj := 0
 WHIL jj < nRango .AND. ! oTable:EOF() .AND. IF( lHTML, .T., ! INKEY() == K_ESC )
  IF ! lesMySQL2
   IF (cAlias2)->(CPERAPPEND(5,.F. )) //Registrar si se agrega registro
    FOR ii = 1 TO LEN( aEstruc2 )
     cVarVal := oTable:FIELDGET( oTable:FIELDPOS(aEstruc2[ ii,1 ]) )
     (cAlias2)->(FIELDPUT( ii, cVarVal ))
    NEXT ii
    DBCOMMITALL()  //Forza escritura disco
    (cAlias2)->(DBRUNLOCK())
   ELSE
    QOUT( IF(lHTML,"<BR>","")+"Error para agregar desde registro: ", oTable:RECNO() )
    QOUT( IF(lHTML,"<BR>","")+"Append error", oTable2:Error() )
   ENDI
  
  ELSE
   oRecord2 := oTable2:GetBlankRow()
   FOR ii = 1 TO LEN( aEstruc2 )
    cVarVal := oTable:FIELDGET( oTable:FIELDPOS(aEstruc2[ ii,1 ]) )
    oRecord2:FIELDPUT( ii, cVarVal )
   NEXT ii
   IF ! oTable2:Append( oRecord2 )
    QOUT( IF(lHTML,"<BR>","")+"Error para agregar desde registro: ", oTable:RECNO() )
    QOUT( IF(lHTML,"<BR>","")+"Append error", oTable2:Error() )
   ENDI
  ENDI
  
  jj := jj+1
  IF ! lHTML .AND. jj % 100 == 0
   nRow0 := ROW()
   @ nRow,0 SAY "Datos copiados: "+STR(jj,10,0)
   SetPos(nRow0,0)
  ENDI
  oTable:SKIP( 1 )

 ENDD
 QOUT( IF(lHTML,"<BR>","") )
 QOUT( IF(lHTML,"<BR>","")+"Total de datos copiados: "+STR(jj,10,0) ;
  +IF(lHTML,"",IF(LASTKEY()==K_ESC," **CANCELADO** ","") ) )
 QOUT( IF(lHTML,"<BR>","")+"Tiempo final: "+DTOC(DATE())+" "+TIME() )
 QOUT( IF(lHTML,"<BR>","")+"Segundos transcurridos: ", SECONDS()-nCheckADS )

 oTable:Destroy()
 oServer:Destroy()
 DO CASE
 CASE ! lesMySQL2
  //DBF a DBF
  (cAlias2)->( DBCLOSEAREA( ) )
 CASE lesMySQL2
  //DBF a MySQL
  oTable2:Destroy()
  oServer2:Destroy()
 ENDC

ENDC

IF lHTML
 QOUT('<br>')
 QOUT('<br>')
 QOUT('<b>Contador de accesos:</b> ' )
 IF ! FILE( cContador )
  MEMOWRIT( cContador, "0" )
 ENDI
  MEMOWRIT( cContador, STR( VAL(MEMOREAD(cContador))+1 )  )
  QQOUT( MEMOREAD(cContador) )
 QOUT('<br>')

 QOUT('</BODY></HTML>' )
 // Cerrar salida
 SGSALIDA0()
ELSE
 QOUT( )
 QOUT( "Pulse cualquier tecla para continuar ..." )
 INKEY(30)
ENDI

RETU


FUNC DMCONDIC
//Condiciones para copiado de datos
PRIV ii
PRIV jj

PRIV aRdd := { "DBFCDX", "DBFNTX" }
PRIV lAds := "WINDOWS" $ UPPE(OS()) .OR. "LINUX" $ UPPE(OS())
IF lAds
 aRdd := { "DBFCDX", "DBFNTX", "DBFCDXAX", "DBFNTXAX", "ADSCDX", "ADSNTX" }
ENDI
PRIV aArchivos

DO CASE
CASE lHTML
/* Se puede usar:
- SGOutStd(): para simular la salida directa al servidor Web
  En este caso no se requiere cArcSale, y no debe usarse QOUT()
- cArcSale y QOUT(): para enviar la salida al archivo cArcSale, el cual es definido y usado por el modelo ClipxNet
  para usarlo como "salida" que se enviara al servidor Web
*/

// Escribir informacion en archivo de salida
SGSALIDA0( cArcSale, .T., .F., .F. )

QOUT('<HTML>')
QOUT('<HEAD><TITLE>Modelo ClipxNet: Condiciones para copiado de datos</TITLE>')
QOUT('   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">' )
QOUT('   <META NAME="Author" CONTENT="David Arturo Macias Corona">' )
QOUT('   <META NAME="GENERATOR" CONTENT="Mozilla/4.04 [en] (OS/2; I) [Netscape]">' )
QOUT('   <META NAME="GENERATOR" CONTENT="Sistemas Genericos [SGD]">' )
QOUT('</HEAD>')

QOUT('<BODY background="'+cSvrLogos+'fondo0.gif" leftMargin=5 topMargin=5>')

QOUT('<div align="center"><center>')
QOUT('<table border="0" cellpadding="1" cellspacing="1" width="100%">')
QOUT('<tr>')
QOUT('<td width="424"><p align="center"><b><font face="Comic Sans MS" color="#000080" size="5">')
QOUT('Condiciones para copiado de datos tipo DBF y/o MySQL')
QOUT('</font></b></td>')
QOUT('</tr>')
QOUT('</table>')
QOUT('</center></div>')
QOUT('<BR>')

QOUT('<FORM METHOD=POST ACTION=dbfmysql.prg name="CondDBF" > ' )
// Valores para Consulta
QOUT('  <!-- Lista de Consulta -->')

QOUT( '<HR>' )
QOUT( '<H3>Condiciones para archivo FUENTE tipo DBF o MySQL:</H3>' )
QOUT('  <div align="center"><center>')
// QOUT('  <table BORDER="0" >')
QOUT('  <table BORDER="0" cellspacing="4" cellpadding="4">')

QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      DBF: Base de datos:</font>')
QOUT('      </td >')
//Para escribir, usar las siguientes dos lineas
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cBaseDbf1" SIZE=50 MAXLENGTH=100 VALUE="'+SGCGIvaria("cBaseDBF1")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      DBF: o listado *.dbf:</font>')
QOUT('      </td >')
//Para lista de archivos *.dbf en el directorio, usar la siguiente seccion
aArchivos := ASORT(DIRECTORY("*.dbf"),,,SGBLOCK("|e1,e2| e1[1]<e2[1]"))
QOUT( '<TD>')
QOUT('<SELECT NAME="cBaseDbf2">')
QOUT('<OPTION CHECKED >' )
FOR ii = 1 TO LEN( aArchivos )
 QOUT('<OPTION>'+aArchivos[ii,1] )
NEXT ii
QOUT('</SELECT>')
QOUT('</td>')
QOUT('    </tr>')

QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      Archivo indice:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cIndice" SIZE=32 MAXLENGTH=32 VALUE="'+SGCGIvaria("cIndice")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      DBF: Orden controlador:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cOrden" SIZE=12 MAXLENGTH=12 VALUE="'+SGCGIvaria("cOrden")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('    </tr>')

QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      DBF: Controlador RDD: </font>' )
QOUT( '</TD>')
QOUT( '<TD>')
QOUT('<SELECT NAME="cRdd">')
FOR ii = 1 TO LEN( aRdd )
 QOUT('<OPTION'+IF(UPPE(SGCGIvaria("cRDD"))=aRdd[ii],' SELECTED','')+'>'+aRdd[ii] )
NEXT ii
QOUT('</SELECT>')
QOUT('</td>')

IF lAds
 QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
 QOUT('      DBF: Tipo de ADS:</font>')
 QOUT('      </td >')
 QOUT( '<TD>')
 QOUT('<SELECT NAME="cADStipo">')
 QOUT('<OPTION'+IF(UPPE(SGCGIvaria("cADStipo"))="LOCAL",' SELECTED','')+'>LOCAL' )
 QOUT('<OPTION'+IF(UPPE(SGCGIvaria("cADStipo"))="REMOTO",' SELECTED','')+'>REMOTO' )
 QOUT('</SELECT>')
 QOUT('</TD>')
ENDI

QOUT('    </tr>')

QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      MySQL: Servidor:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cMySQLhost" SIZE=50 MAXLENGTH=50 VALUE="'+SGCGIvaria("cMySQLhost")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('    </tr>')
QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      MySQL: Usuario:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cMySQLuser" SIZE=20 MAXLENGTH=20 VALUE="'+SGCGIvaria("cMySQLuser")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      MySQL: Password:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=PASSWORD NAME="cMySQLpass" SIZE=20 MAXLENGTH=20 VALUE="'+SGCGIvaria("cMySQLpass")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('    </tr>')

QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      MySQL: Base de datos:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cBaseSQL" SIZE=50 MAXLENGTH=100 VALUE="'+SGCGIvaria("cBaseSQL")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      MySQL: Tabla de datos:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cTableSQL" SIZE=32 MAXLENGTH=32 VALUE="'+SGCGIvaria("cTableSQL")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('    </tr>')

QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      Registro inicial:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="nRecno" SIZE=8 MAXLENGTH=8 VALUE="'+SGCGIvaria("nRecno")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      Rango de registros:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="nRango" SIZE=8 MAXLENGTH=8 VALUE="'+SGCGIvaria("nRango")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('    </tr>')
QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      Filtro/WHERE:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <input type="text" name="cFiltro" size="50" maxlength="150" VALUE="'+SGCGIvaria("cFiltro")+'" style="font-family: Comic Sans MS; font-size: 10pt">')
QOUT('      </td >')
QOUT('    </tr>')
QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      Campos:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <input type="text" name="cCampos" size="50" maxlength="150" VALUE="'+SGCGIvaria("cCampos")+'" style="font-family: Comic Sans MS; font-size: 10pt">')
QOUT('      </td >')
QOUT('    </tr>')

QOUT('  </table>')
QOUT('  </center></div><div align="center"><center><p>&nbsp; </p>')
QOUT('  </center></div>')

QOUT( '<HR>' )
QOUT( '<H3>Condiciones para archivo DESTINO tipo DBF o MySQL:</H3>' )
QOUT('  <div align="center"><center>')
// QOUT('  <table BORDER="0" >')
QOUT('  <table BORDER="0" cellspacing="4" cellpadding="4">')

QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      Crear archivo/tabla:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=CHECKBOX NAME="lCrear2" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('    </tr>')

QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      DBF: Base de datos:</font>')
QOUT('      </td >')
//Para escribir, usar las siguientes dos lineas
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cBaseDbf12" SIZE=50 MAXLENGTH=100 VALUE="'+SGCGIvaria("cBaseDBF12")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      DBF: o listado *.dbf:</font>')
QOUT('      </td >')
//Para lista de archivos *.dbf en el directorio, usar la siguiente seccion
aArchivos := ASORT(DIRECTORY("*.dbf"),,,SGBLOCK("|e1,e2| e1[1]<e2[1]"))
QOUT( '<TD>')
QOUT('<SELECT NAME="cBaseDbf22">')
QOUT('<OPTION CHECKED >' )
FOR ii = 1 TO LEN( aArchivos )
 QOUT('<OPTION>'+aArchivos[ii,1] )
NEXT ii
QOUT('</SELECT>')
QOUT('</td>')
QOUT('    </tr>')

QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      Archivo indice:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cIndice2" SIZE=32 MAXLENGTH=32 VALUE="'+SGCGIvaria("cIndice2")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      DBF: Orden controlador:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cOrden2" SIZE=12 MAXLENGTH=12 VALUE="'+SGCGIvaria("cOrden2")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('    </tr>')

QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      DBF: Controlador RDD: </font>' )
QOUT( '</TD>')
QOUT( '<TD>')
QOUT('<SELECT NAME="cRdd2">')
FOR ii = 1 TO LEN( aRdd )
 QOUT('<OPTION'+IF(UPPE(SGCGIvaria("cRDD2"))=aRdd[ii],' SELECTED','')+'>'+aRdd[ii] )
NEXT ii
QOUT('</SELECT>')
QOUT('</td>')

IF lAds
 QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
 QOUT('      DBF: Tipo de ADS:</font>')
 QOUT('      </td >')
 QOUT( '<TD>')
 QOUT('<SELECT NAME="cADStipo2">')
 QOUT('<OPTION'+IF(UPPE(SGCGIvaria("cADStipo2"))="LOCAL",' SELECTED','')+'>LOCAL' )
 QOUT('<OPTION'+IF(UPPE(SGCGIvaria("cADStipo2"))="REMOTO",' SELECTED','')+'>REMOTO' )
 QOUT('</SELECT>')
 QOUT('</TD>')
ENDI

QOUT('    </tr>')

QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      MySQL: Servidor:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cMySQLhost2" SIZE=50 MAXLENGTH=50 VALUE="'+SGCGIvaria("cMySQLhost2")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('    </tr>')
QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      MySQL: Usuario:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cMySQLuser2" SIZE=20 MAXLENGTH=20 VALUE="'+SGCGIvaria("cMySQLuser2")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      MySQL: Password:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=PASSWORD NAME="cMySQLpass2" SIZE=20 MAXLENGTH=20 VALUE="'+SGCGIvaria("cMySQLpass2")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      </td >')
QOUT('    </tr>')

QOUT('    <tr>')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      MySQL: Base de datos:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cBaseSQL2" SIZE=50 MAXLENGTH=100 VALUE="'+SGCGIvaria("cBaseSQL2")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('      <td ALIGN="right" bgcolor="#000080"><font face="Comic Sans MS" color="#FFFFFF" size="2">')
QOUT('      MySQL: Tabla de datos:</font>')
QOUT('      </td >')
QOUT('      <td >')
QOUT('      <INPUT TYPE=TEXT NAME="cTableSQL2" SIZE=32 MAXLENGTH=32 VALUE="'+SGCGIvaria("cTableSQL2")+'" STYLE="font-family: Comic Sans MS; font-size: 10pt" >')
QOUT('    </tr>')

QOUT('  </table>')
QOUT('  </center></div><div align="center"><center><p>&nbsp; </p>')
QOUT('  </center></div>')

QOUT('  <div align="center"><center><p>')

QOUT('  </p></center></div>')

QOUT('  <div align="center"><center><p>')
QOUT('<INPUT TYPE=SUBMIT VALUE="Ejecutar">')
QOUT('<INPUT TYPE=RESET VALUE="Limpiar">')
QOUT('  </p></center></div>')

QOUT('</FORM>')

QOUT('</BODY></HTML>' )
// Cerrar salida
SGSALIDA0()

CASE ! lHTML

cBaseDBF1 := SPAC( 100 )
cBaseDbf2 := SPAC(32)
cIndice := SPAC( 32 )
cOrden := SPAC( 12 )
cRdd := PADR( aRdd[ 1 ], 12 )
cADStipo := PADR( "LOCAL", 6 )

cMySQLhost := SPAC(50)
cMySQLuser := SPAC(20)
cMySQLpass := SPAC(20)
cBaseSQL := SPAC( 100 )
cTableSQL := SPAC( 32 )
nRecno := 0
nRango := 0
cFiltro := SPAC( 150 )
cCampos := SPAC( 150 )

lCrear2 := .F.
cBaseDBF12 := SPAC( 100 )
cBaseDbf22 := SPAC(32)
cIndice2 := SPAC( 32 )
cOrden2 := SPAC( 12 )
cRdd2 := PADR( aRdd[ 1 ], 12 )
cADStipo2 := PADR( "LOCAL", 6 )

cMySQLhost2 := SPAC(50)
cMySQLuser2 := SPAC(20)
cMySQLpass2 := SPAC(20)
cBaseSQL2 := SPAC( 100 )
cTableSQL2 := SPAC( 32 )

SetMode( 50, 80 )   //Se ocupan filas voluntarias ...
SCROLL( )

//Raton
SET EVENTMASK TO 159   //INKEY_ALL
MSETCURSOR( TRUE )

@ 0, 0 SAY 'Modelo ClipNet-xNet - dmacias@mail.udg.mx' COLOR "BG+/B"
@ ROW()+2, 10 SAY 'Condiciones para copiado de datos tipo DBF y/o MySQL'
@ ROW()+2, 0 SAY PADR( 'Condiciones para archivo FUENTE tipo DBF o MySQL:', MAXCOL()+1 ) COLOR "W+/R"
@ ROW()+1, 0 SAY 'DBF: Base de datos:' GET cBaseDbf1 PICTURE "@S50"
//Para lista de archivos *.dbf en el directorio, usar la siguiente seccion
aArchivos := ASORT(DIRECTORY("*.dbf"),,,SGBLOCK("|e1,e2| e1[1]<e2[1]"))

FOR ii = 1 TO LEN( aArchivos )
 aArchivos[ii] := aArchivos[ii,1]
NEXT ii
/* LISTBOX no funciona correctamente

#include "hbgetcmt.ch"
cBaseDbf2 := aArchivos[ 1 ]

//LISTBOX, de HBGETCMT.ch
SetPos( ROW()+1, 0)
AAdd( GetList, _GET_( cBaseDbf2, "cBaseDbf2", NIL, , {|| EMPTY(cBaseDbf1)} ) )
ATail(GetList):Control := _ListBox_( ATail(Getlist):row, ATail(Getlist):col, ;
 ROW()+5, 20, cBaseDbf2, aArchivos, 'DBF: o listado *.dbf', , , , , .T., )
 ATail(GetList):reader := { | a, b, c, d | GuiReader( a, b, c, d ) }
 ATail(GetList):Control:Display()

//@ ROW()+1, 0, ROW()+5,20 GET cBaseDbf2 LISTBOX aArchivos ;
// CAPTION 'DBF: o listado *.dbf'

// qout( cBaseDbf2 )
// inkey(0)
*/

@ ROW()+1, 0 SAY 'Archivo indice:' GET cIndice
@ ROW()+1, 0 SAY 'DBF: Orden controlador:' GET cOrden
@ ROW()+1, 0 SAY 'DBF: Controlador RDD:' GET cRdd PICTURE "@!"
//LISTBOX no funciona bien
FOR ii = 1 TO LEN( aRdd )
 @ROW(), COL()+1 SAY aRdd[ii]
NEXT ii
IF lAds
 //LISTBOX no funciona bien
 @ ROW()+1, 0 SAY 'DBF: Tipo de ADS:' GET cADStipo PICTURE "@!"
 @ROW(), COL()+1 SAY "LOCAL REMOTO"
ENDI

@ ROW()+1, 0 SAY 'MySQL: Servidor:' GET cMySQLhost
@ ROW()+1, 0 SAY 'MySQL: Usuario:' GET cMySQLuser
@ ROW(), COL()+5 SAY 'MySQL: Password:' GET cMySQLpass
@ ROW()+1, 0 SAY 'MySQL: Base de datos:' GET cBaseSQL PICTURE "@S50"
@ ROW()+1, 0 SAY 'MySQL: Tabla de datos:' GET cTableSQL
@ ROW()+1, 0 SAY 'Registro inicial:' GET nRecno
@ ROW(), COL()+5 SAY 'Rango de registros:' GET nRango
@ ROW()+1, 0 SAY 'Filtro/WHERE:' GET cFiltro PICTURE "@S50"
@ ROW()+1, 0 SAY 'Campos:' GET cCampos PICTURE "@S50"

@ ROW()+2, 0 SAY PADR( 'Condiciones para archivo DESTINO tipo DBF o MySQL:', MAXCOL()+1 ) COLOR "W+/R"
@ ROW()+1, 0 SAY 'Crear archivo/tabla:' GET lCrear2
@ ROW()+1, 0 SAY 'DBF: Base de datos:' GET cBaseDbf12 PICTURE "@S50"
/* LISTBOX no funciona
QOUT('      DBF: o listado *.dbf:</font>')
QOUT('<SELECT NAME="cBaseDbf22">')
*/

@ ROW()+1, 0 SAY 'Archivo indice:' GET cIndice2
@ ROW()+1, 0 SAY 'DBF: Orden controlador:' GET cOrden2
@ ROW()+1, 0 SAY 'DBF: Controlador RDD:' GET cRdd2 PICTURE "@!"
//LISTBOX no funciona bien
FOR ii = 1 TO LEN( aRdd )
 @ROW(), COL()+1 SAY aRdd[ii]
NEXT ii
IF lAds
 //LISTBOX no funciona bien
 @ ROW()+1, 0 SAY 'DBF: Tipo de ADS:' GET cADStipo2 PICTURE "@!"
 @ROW(), COL()+1 SAY "LOCAL REMOTO"
ENDI

@ ROW()+1, 0 SAY 'MySQL: Servidor:' GET cMySQLhost2
@ ROW()+1, 0 SAY 'MySQL: Usuario:' GET cMySQLuser2
@ ROW(), COL()+5 SAY 'MySQL: Password:' GET cMySQLpass2
@ ROW()+1, 0 SAY 'MySQL: Base de datos:' GET cBaseSQL2 PICTURE "@S50"
@ ROW()+1, 0 SAY 'MySQL: Tabla de datos:' GET cTableSQL2
@ ROW()+2,0 SAY "{Esc} para salir ..."
nRow := ROW()+2
READ
IF LASTKEY() == K_ESC
 RETU .F.
ENDI
SetPos( nRow, 0 )
cBaseDBF1 := ALLTRIM( cBaseDBF1 )
cBaseDBF2 := ALLTRIM( cBaseDBF2 )
cIndice := ALLTRIM( cIndice )
cOrden := ALLTRIM( cOrden )
cRdd := UPPE(ALLTRIM( cRdd ))
cADStipo :=  UPPE(ALLTRIM( cADStipo ))

cMySQLhost := ALLTRIM( cMySQLhost )
cMySQLuser := ALLTRIM( cMySQLuser )
cMySQLpass := ALLTRIM( cMySQLpass )
cBaseSQL := ALLTRIM( cBaseSQL )
cTableSQL := ALLTRIM( cTableSQL )
cFiltro := ALLTRIM( cFiltro )
cCampos := ALLTRIM( cCampos )

cBaseDBF12 := ALLTRIM( cBaseDBF12 )
cBaseDBF22 := ALLTRIM( cBaseDBF22 )
cIndice2 := ALLTRIM( cIndice2 )
cOrden2 := ALLTRIM( cOrden2 )
cRdd2 := UPPE(ALLTRIM( cRdd2 ))
cADStipo2 :=  UPPE(ALLTRIM( cADStipo2 ))

cMySQLhost2 := ALLTRIM( cMySQLhost2 )
cMySQLuser2 := ALLTRIM( cMySQLuser2 )
cMySQLpass2 := ALLTRIM( cMySQLpass2 )
cBaseSQL2 := ALLTRIM( cBaseSQL2 )
cTableSQL2 := ALLTRIM( cTableSQL2 )

ENDC
RETU .T.


FUNC DMSALE( xAviso, lSale )
//Mostrar avisos cerrar en su caso
LOCAL ii
 IF xAviso == NIL ; xAviso := "" ; ENDI
 IF lSale == NIL ; lSale := .T. ; ENDI
IF VALTYPE( xAviso ) == "C"
 //Separar elementos del aviso
 xAviso := SGPTOD( xAviso, ";", , FALSE )
ENDI
IF lHTML
 FOR ii = 1 TO LEN( xAviso )
  QOUT('<CENTER><H2>'+xAviso[ ii ]+'</H2></CENTER>' )
 NEXT ii
 IF lSale
  QOUT('<BR>' )
  QOUT('</BODY></HTML>' )
  // Cerrar salida
  SGSALIDA0()
 ENDI
ELSE
 FOR ii = 1 TO LEN( xAviso )
  QOUT( xAviso[ ii ] )
 NEXT ii
 INKEY(15)
ENDI
RETU NIL

