/*  12 Julio 2003
I.Q. David Arturo Macias Corona
BMP2JPG.prg:  Ejemplos de Modelo ClipNet-xNet con TGraph 3
Basado en: SisGen:SGVISUAL.prg:SGDSK2DSK()

Este programa es solo para Clipper/LightLib
 Se usa para generar un archivo .jpg a partir de un archivo .bmp, ya que en FiveWin no
 es posible generar un archivo .jpg
*/

 #define  CRLF   CHR(13)+CHR(10)

 #include "Button.Ch"
 #include "GetExit.Ch"
 #include 'llibo.ch'          //  Usar Light Lib Objects
 #include 'llibg.ch'          //  Usar Light Lib Graphics
 #include 'llibgtoo.ch'       //  Usar Light Lib Graphics tools
 #include 'llibi.ch'          //  Usar Light Lib Images
 #include 'llibitoo.ch'       //  Usar Light Lib Images tools
 #include 'llibb.ch'          //  Usar Light Lib Business
 #include 'llibbtoo.ch'       //  Usar Light Lib Business tools

#include "INKEY.CH"
#include "COMMON.CH"
#include "setcurs.ch"

FUNC BMP2JPG( cFileBMP )
// Archivo BMP a Archivo JPG
LOCAL nOldShape, dwImage, dwZoom, cFileJPG
IF ! FILE( cFileBMP )
 RETU NIL
ENDI
cFileBMP := LOWE( cFileBMP )
// Leer archivo BMP
//Original
dwImage := iGet(dwLLApp(), ;
           LLI_DISK      , ;
           LLI_DISK_AUTO , ;
           0, 0, LLI_FULL_SIZE, LLI_FULL_SIZE,;
           cFileBMP, ;
           LLI_VOID_PARAM, ;
           LLI_VOID_PARAM, ;
           LLI_VOID_PARAM, ;
           LLI_VOID_PARAM, ;
           LLI_VOID_PARAM )
	   
// ? oAccess(dwImage,LLI_IMAGE_BITS   ,LLI_VOID_PARAM)
// INKEY(0)           

/*
   //Para ventana
   dwZoom := iGet(dwLLApp()       ,;
          LLI_MEMORY              ,;
          LLI_MEMORY_16M          ,;
          0 , 0 , oAccess(dwImage,LLI_IMAGE_WIDTH  ,LLI_VOID_PARAM) , oAccess(dwImage,LLI_IMAGE_HEIGHT ,LLI_VOID_PARAM) ,;
          { 255, 0, 0 }           ,;
          LLI_VOID_PARAM          ,;
          LLI_VOID_PARAM          ,;
          LLI_VOID_PARAM          ,;
          LLI_VOID_PARAM          ,;
          LLI_VOID_PARAM )

//          oAccess(dwImage,LLI_IMAGE_BITS   ,LLI_VOID_PARAM) ,;
// 15

   //Poner imagen en ventana
   iPut( dwImage ,;
          LLI_FULL_SIZE , LLI_FULL_SIZE , LLI_FULL_SIZE , LLI_FULL_SIZE , ;
          LLI_MEMORY , ;
          LLI_VOID_PARAM , ;
          0 , 0 ,;
          dwZoom , ;
          LLI_VOID_PARAM , ;
          LLI_VOID_PARAM , ;
          LLI_VOID_PARAM , ;
          LLI_VOID_PARAM , ;
          LLI_VOID_PARAM )
   dwImage := oDel( dwImage )

   // Poner en original
   dwImage := iCopy( dwZoom ,;
          LLI_FULL_SIZE  , LLI_FULL_SIZE , LLI_FULL_SIZE , LLI_FULL_SIZE  ,;
          LLI_COPY_CLONE ,;
          LLI_VOID_PARAM ,;
          LLI_VOID_PARAM ,;
          LLI_VOID_PARAM ,;
          LLI_VOID_PARAM ,;
          LLI_VOID_PARAM ,;
          LLI_VOID_PARAM )
   dwZoom := oDel( dwZoom )
*/

   dwZoom := iCopy( dwImage ,;
          LLI_FULL_SIZE  , LLI_FULL_SIZE , LLI_FULL_SIZE , LLI_FULL_SIZE  ,;
          LLI_COPY_QUANTIZE ,;
          LLI_DITHER_ON ,;
          LLI_SCALE_COLOR ,;
          256 ,;
          LLI_VOID_PARAM ,;
          LLI_VOID_PARAM ,;
          LLI_VOID_PARAM )

// Grabar en disco
// iPut( dwImage ,;

iPut( dwZoom ,;
      LLI_FULL_SIZE , LLI_FULL_SIZE , LLI_FULL_SIZE , LLI_FULL_SIZE ,;
      LLI_DISK ,;
      LLI_DISK_JPG ,;
      0 , 0 ,;
      STRTRAN( cFileBMP, "bmp", "jpg" ) ,;
      LLI_VOID_PARAM ,;
      LLI_VOID_PARAM ,;
      LLI_VOID_PARAM ,;
      LLI_VOID_PARAM ,;
      LLI_VOID_PARAM )
dwImage := oDel( dwImage )

   dwZoom := oDel( dwZoom )

// TONE(1000,1)
RETU NIL

/*
                          LLI_COPY_QUANTIZE
                              dwParam1    Flag (LLI_DITHER_ON|LLI_DITHER_OFF)
                              dwParam2    Flag (LLI_SCALE_COLOR|LLI_SCALE_GRAY)
                              dwParam3    Number of colors (1-256)
*/

