/* 2003/07/12: I.Q. David Arturo Macias Corona   inter_01.prg

Proceso para: Prueba 01 de Interfaz con Modelo en Serie
*/

#define  TRUE   .T.
#define  FALSE  .F.
#define  K_ESC  27


FUNC MAIN
PARA xParam   //Archivo de control de interfaz
PRIV cSvrLogos := "../cgi-bin/logos/"
PRIV cArcInterfaz   //Archivo de control de interfaz
PRIV cArcEntra
PRIV cArcSale
PRIV cCadena,ii,cLinea

IF ! TYPE("XPARAM")=="C"
 xParam := ""
ENDI

//Valores de sustitucion
cArcInterfaz := LOWE( xParam )
IF EMPTY( cArcInterfaz )
 RETU NIL
ENDI

FOR ii = 1 TO MLCOUNT(cCadena,254)
 cLinea := MEMOLINE(cCadena, 254, ii )
 IF EMPTY( cLinea )
  LOOP
 ENDI
 &cLinea
NEXT ii

xCadena := ALLTRIM( MEMOREAD( cArcInterfaz ) )
//Evaluar cada linea para que se asignen cArcEntra y cArcSale
//Nota: MLCOUNT()/MEMOLINE() es lento, asi que es mas eficiente separar por CR+LF
//DAVID: MEMOLINE() no respeta CRLF en Harbour de FWH Jul2003, y si lo hace en Harbour 42 oficial
 //Prevision para LF=CHR(10) como fin de linea en Linux
 IF ! CHR(13)+CHR(10) $ xCadena
  xCadena := STRTRAN( xCadena, CHR(10), CHR(13)+CHR(10) )
 ENDI
xCadena := SGTTOA( xCadena, CHR(13)+CHR(10) )   //Texto TO Array
FOR ii = 1 TO LEN(xCadena)
 cLinea := xCadena[ ii ]
 IF EMPTY( cLinea )
  LOOP
 ENDI
 IF ":=" $ cLinea   //Evaluar para asignar
  EVAL( &( "{ | | "+cLinea+"}" ) )
 ENDI
NEXT ii

 //Procesar y escribir informacion de salida
 SET CONSOLE OFF
 SET PRINTER TO (cArcSale)
 SET PRINTER ON
 QOUT('<HTML>')
 QOUT('<HEAD><TITLE>Modelo ClipNet: Prueba 01 de Interfaz con Modelo en Serie</TITLE>')
 QOUT('   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">' )
 QOUT('   <META NAME="Author" CONTENT="David Arturo Macias Corona">' )
 QOUT('   <META NAME="GENERATOR" CONTENT="Mozilla/4.04 [en] (OS/2; I) [Netscape]">' )
 QOUT('   <META NAME="GENERATOR" CONTENT="Sistemas Genericos [SGD]">' )
 QOUT('</HEAD>')

 QOUT('<BODY background="'+cSvrLogos+'fondo0.gif" leftMargin=5 topMargin=5>')
// QOUT('<p align="center">' )
// QOUT('<img border="0" src="../cgi-bin/logos/logo.jpg" width="750" height="57" >')
// QOUT('</p>')

 QOUT( "Computadora: "+NETNAME()+", Fecha y hora: "+DTOC(DATE())+" "+TIME()+"<BR>" )
 QOUT('<CENTER><H2>Prueba 01 de Interfaz con Modelo en Serie</H2></CENTER>' )
 QOUT( "<HR>" )
 QOUT( "Archivo de entrada, cArcEntra = "+cArcEntra+"<BR>" )
 QOUT( "Archivo de salida,  cArcSale  = "+cArcSale +"<BR>" )
 QOUT( "Archivo de control de interfaz,  cArcInterfaz = "+cArcInterfaz +"<BR>" )

 QOUT( "<BR>" )
 QOUT( "Contenido de Archivo de entrada:<BR>" )
 QOUT( "<PRE>" )
 QOUT( MEMOREAD( cArcEntra ) )
 QOUT( "</PRE>" )

 QOUT('<BR>' )
 QOUT('</BODY></HTML>' )
 // Cerrar salida
 SET PRINTER OFF
 SET PRINTER TO
 SET CONSOLE OFF

RETU NIL


FUNC SGTTOA( cLisPares, cDelimita )
//DAVID: Vector de elementos separados. Auxiliar basado en SGPTOD()
LOCAL nPos,cVarVal,aMatDic:={}
IF cLisPares == NIL
 RETU aMatDic
ENDI
  //Por delimitador
  IF ! VALTYPE( cLisPares )=="C" .OR. ! VALTYPE( cDelimita ) == "C"
   RETU aMatDic
  ENDI
  WHIL ! EMPTY( cLisPares )
   IF ! ( nPos := AT( cDelimita, cLisPares ) ) == 0   //Posicion de delimitador
    cVarVal := LEFT( cLisPares, nPos - 1 )  //Extraer linea
    cLisPares := SUBS( cLisPares, nPos + LEN( cDelimita ) )  //Texto restante
   ELSE
    cVarVal := cLisPares ; cLisPares := SPAC(0)
   ENDI
   AADD( aMatDic, cVarVal )
  ENDD
RETU aMatDic
